# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%{?scl:%scl_package rhino}
%{!?scl:%global pkg_name %{name}}
%define cvs_version 1_7R3

Name:           %{?scl_prefix}rhino
Version:        1.7R3
Release:        1%{?dist}
Epoch:          0
Summary:        JavaScript for Java
License:        GPL+ and LGPL+ and Netscape and MPLv1.0 and (MPLv1.1 or GPLv2+)

Source0:        ftp://ftp.mozilla.org/pub/mozilla.org/js/rhino%{cvs_version}.zip

Source2:        %{pkg_name}.script

URL:            http://www.mozilla.org/rhino/
Group:          Development/Libraries/Java

BuildRequires:  ant
BuildRequires:  bea-stax-api
BuildRequires:  java-1.6.0-openjdk-devel >= 1:1.6.0.0
Requires:       jpackage-utils
Requires:       jline

%{?scl:Requires: %scl_runtime}

# Disable xmlbeans until we can get it into Fedora
#Requires:       xmlbeans
#BuildRequires:  xmlbeans
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{pkg_name}-%{version}-%{release}-root-%(%{__id_u} -n)

Obsoletes:      %{pkg_name}-manual <= %{epoch}:%{version}-%{release}

%description
Rhino is an open-source implementation of JavaScript written entirely
in Java. It is typically embedded into Java applications to provide
scripting to end users.

%package        demo
Summary:        Examples for %{name}
Group:          Development/Libraries/Java

%description    demo
Examples for %{name}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{pkg_name}%{cvs_version}

# Fix build
%{__perl} -pi -e 's|.*<get.*src=.*>\n||' build.xml testsrc/build.xml toolsrc/org/mozilla/javascript/tools/debugger/build.xml xmlimplsrc/build.xml

# Fix manifest
%{__perl} -pi -e 's|^Class-Path:.*\n||g' src/manifest

# Add jpp release info to version
%{__perl} -pi -e 's|^implementation.version: Rhino .* release .* \${implementation.date}|implementation.version: Rhino %{version} release %{release} \${implementation.date}|' build.properties

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%ant -Dxbean.jar=$(build-classpath xmlbeans/xbean) \
     -Djsr173.jar=$(build-classpath bea-stax-api) deepclean jar copy-all javadoc

#pushd examples
# xbeans component is optional. Disabled until we can get it into Fedora
#export CLASSPATH=../build/%{name}%{cvs_version}/js.jar:$(build-classpath xmlbeans/xbean)

#export CLASSPATH=../build/%{name}%{cvs_version}/js.jar:$(build-classpath xmlbeans/xbean 2>/dev/null)
# TODO: get examples working again
#%{javac} *.java
#%{jar} cvf ../build/%{name}%{cvs_version}/%{name}-examples-%{version}.jar *.class
#popd

%install
%__rm -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -a build/%{pkg_name}%{cvs_version}/js.jar %{buildroot}%{_javadir}/%{pkg_name}-%{version}.jar
# TODO: get examples working again
#%{__cp} -a build/%{pkg_name}%{cvs_version}/%{pkg_name}-examples-%{version}.jar %{buildroot}%{_javadir}/%{pkg_name}-examples-%{version}.jar
(cd %{buildroot}%{_javadir} && %{__ln_s} %{pkg_name}-%{version}.jar js-%{version}.jar)
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `echo $jar| %{__sed} "s|-%{version}||g"`; done)

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a build/%{pkg_name}%{cvs_version}/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
%{?scl:%_root_bindir}%{?!scl:%_bindir}/find %{buildroot}%{_javadocdir}/%{name}-%{version} -type f -name '*.html' | %{?scl:%_root_bindir}%{?!scl:%_bindir}/xargs %{__perl} -pi -e 's/\r$//g'

## script
%__mkdir_p %{buildroot}%{_bindir}
%__install -m 755 %{SOURCE2} %{buildroot}%{_bindir}/%{pkg_name}

# examples
# TODO: get examples working again
#%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
#%{__cp} -a examples/* %{buildroot}%{_datadir}/%{name}

%clean
%__rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{pkg_name}
%{_javadir}/*

%files demo
%defattr(0644,root,root,0755)
# TODO: examples
#%{_datadir}/%{pkg_name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/*

%changelog
* Tue Mar 12 2013 Devan Goodwin <dgoodwin@redhat.com> - 1.7R3-1
- Initial build for Candlepin software collection.
